module.exports = function() {
  var t = this;
  var lastEvent;
  this.load = function(input) {
    lastEvent = input.fancyname+" done";
    input.getPageList(function(list) {
      t.emit(input.fancyname+" done", list);
    });
    return this;
  }

  this.registerNext = function(obj) {
    // pre
    t.on(lastEvent, function(list) {
      if(obj.pre !== undefined) {
        obj.pre(function() {
          t.emit(obj.fancyname+' pre done', list);
        }, list);
      } else {
        t.emit(obj.fancyname+' pre done', list);
      }
    });
    // forEachPage
    t.on(obj.fancyname+' pre done', function(list) {
      var transforming = list.length;
      if(obj.forEachPage !== undefined) {
        list.forEach(function(article) {
          obj.forEachPage(article, function() {
            transforming--;
            if(transforming == 0) {
              t.emit(obj.fancyname+' forEachPage done', list);
            }
          });
        });
      } else {
        t.emit(obj.fancyname+' forEachPage done', list);
      }
    });
    // post
    t.on(obj.fancyname+' forEachPage done', function(list) {
      if(obj.post !== undefined) {
        obj.post(function() {
          t.emit(obj.fancyname+' post done', list);
        }, list)
      } else {
        t.emit(obj.fancyname+' post done', list);
      }
    });

    lastEvent = obj.fancyname+' post done';
    return this;
  }

  this.finish = function(f) {
    t.on(lastEvent, f);
  }
}

module.exports.prototype.__proto__ = require('events').EventEmitter.prototype;
